import time
import random

event_id = 0 # for debug purposes
class Event:
    def __init__(self, time, operation, *args):
        self.time = time
        self.operation = operation
        self.args = args
    def process(self):
        #print("Processing event at time", self.time)
        return self.operation(self.args)

class EventSimulator:
    """
        Simulate the network
        call startSimulation to start the simulation
    """
    def __init__(self, args):
        """
            Initialize the simulator with the given parameters
        """
        self.queue = []
        self.sim_time = args.sim_time
        self.curr_time = 0
        print("Created an Event Simulator with sim_time", self.sim_time)

    def startSimulation(self):
        """
            Start the simulation. 
            Run till the simulation time is reached or the queue is empty
        """
        print("Starting the simulation")
        while len(self.queue) > 0 and self.queue[0].time < self.sim_time:
            event = self.queue.pop(0)
            self.curr_time = event.time
            event.process()
        return

    def push_event(self, event):
        """
            Add event to the queue just before the time it is supposed to occur
        """
        #print(self.curr_time, "Pushing event at time", event.time)
        #time.sleep(2)
        for i in range(len(self.queue)):
            if self.queue[i].time > event.time:
                self.queue.insert(i, event)
                break
        else:
            self.queue.append(event)
        
        return